{
Not Just Another Fuc*ing Space Shooter


Copyright (c) 2006 Jan Jirkovsky
based upon code samples in Asphyre v1.1.0 [ PRO Edition ] by Yuriy Kotsarenko
see http://www.afterwarp.net/ for more info about Asphyre Component Pack

//---------------------------------------------------------------------------
// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you may not use this file except in
// compliance with the License. You may obtain a copy of the License at
// http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
// License for the specific language governing rights and limitations
// under the License.
//---------------------------------------------------------------------------

}




{

---
GAMEOBJECTS.PAS
Unit for object related manipulation with spaceships and shots.
Includes both object and object list implementation.
---


Code of part of this unit is based upon source codes of
Asphyre Objects (or AObjects) by Yuriy Kotsarenko.

I learned a lot from original codes, I used them and I added few new features.
I also moved them from original library pack to my own unit, because Asphyre
Component pack suffered a lot of changes and I wanted my code to be
more or less functional with any Asphyre version,
changing only graphical routines.

For example, I added my own (and I think better) collision support. This way,
every object can have more than 1 collision area, e.g. Boss has about 4 or 5...

I would like to thank Yuriy Kotsarenko on this place and I wish
him and Asphyre only the best!

The second part of this file consists of definitions and specifications
of different types of units. Concept of this game was to make small game with
few enemies, but it can be used more universally - new unique
enemy types can be added quite easily, with a few lines of code...
}

unit gameobjects;

interface
uses AsphyreImages,AsphyreDef, Types,AsphyreCanvas,math;

const MaxCollisionAreas=5;

      minxposition=2;
      minyposition=5;
      maxxposition=280;
      maxyposition=200;

      xsize=300;
      ysize=220;


     pathStraight=1;
     pathToXYThenStraight=2;
     pathToXYThenContinue=3;
     pathSinusoid=4;
     pathCopy=5;

     HammerHeadDispatch=5;
     HammerHeadExplode=80;

     HammerHeadYDifference=17;
     HammerHeadXDifference=6;

     PlayerShootFreq=12;
     PlayerShootFreqmin=7;

     IntroLength=2000;

     hammerspeedcoef=2;

     BossMaxLife=100;





type

TObjectManager = class;
TFragmentManager = class;




//--------------------------------TFragment------------------------------
 TFragment = class
 private

 protected

 public
     Owner: TFragmentManager;
     Prev : TFragment;
     Next : TFragment;

     MaxDuration: cardinal;
     Duration: cardinal;
     Dying : boolean;

     Effect: cardinal;
     Color: cardinal;

     Position: TPoint2;
     Velocity: TPoint2;

  procedure Unlink();
  procedure Move(); virtual;
  procedure Render(Tag: TObject); virtual;

  constructor Create(AOwner: TFragmentManager; APosition: TPoint2;AVelocity: TPoint2; AMaxDuration : integer); virtual;
  destructor Destroy(); override;
 end;


//--------------------------------TFragmentManager------------------------------

 TFragmentManager = class
 private
  function GetCount(): Integer;
 protected

  ListHead,
  ListTail: TFragment;

  procedure UnlinkObj(Obj: TFragment);


 public

  property Count: Integer read GetCount;

  procedure RemoveAll();
  procedure Update();
  procedure Render(Tag: TObject);
  procedure Insert(Obj: TFragment);

  constructor Create();
  destructor Destroy(); override;
 end;


//----------------------------------TSpaceObject-----------------------------------------

 TSpaceObject = class
 private
 protected
 public
     Owner: TObjectManager;
     Prev : TSpaceObject;
     Next : TSpaceObject;

     Dying: Boolean;

     Image: TAsphyreImage;

     Position: TPoint2;
     Velocity: TPoint2;

     Life : integer;

     Collided: Boolean;
     TempCollisionArea: array [1..MaxCollisionAreas] of TRect;
     CollisionArea: array [1..MaxCollisionAreas] of TRect;
     CollisionAreas : integer;
     LastCollisionCenter: TPoint2;
     ScoreValue:integer;


  procedure Unlink();
  procedure CollideCheck(DestObj: TSpaceObject; Distance: Integer; var Accept: Boolean); virtual;
  procedure ObjectCollide(DestObj: TSpaceObject); virtual;
  procedure Move(); virtual;
  procedure Render(Tag: TObject); virtual;
  procedure Explosion(); virtual;
  procedure RenderCollision();  virtual;
  procedure CopyCollisionAreas(); virtual;
  procedure AddCollisionArea (plocha: TRect);


  procedure GetDamage(damage:integer); virtual;

  constructor Create(AOwner: TObjectManager; APosition: TPoint2); virtual;
  destructor Destroy(); override;
 end;

//----------------------------------TObjectManager-----------------------------------------

 TObjectManager = class
 private
  FCollideFreq: Integer;
  FCollideLast: integer;

  function GetCount(): Integer;

 protected

  ListHead,
  ListTail: TSpaceObject;

  procedure UnlinkObj(Obj: TSpaceObject);


 public
  //asistent: TManager;
  property Count: Integer read GetCount;

  procedure RemoveAll();
  procedure Move();
  procedure MoveALLbyX(x:integer);
  procedure Update();
  procedure Render(Tag: TObject);
  procedure Insert(Obj: TSpaceObject); virtual;

  procedure CollideWithManager(Cil: TObjectManager);
  procedure DoCollide(Obj: TSpaceObject);
  constructor Create();
  destructor Destroy(); override;
 end;



//----------------------------------TPlayerShip-----------------------------------------


 TPlayerShip =  class(TSpaceObject)

 private
 protected
 public
              Dead: boolean;
              LastShot: integer;
              Accel : real;
              Speed : real;

  procedure GetDamage(damage:integer); override;
  procedure Shoot1;
  procedure Shoot2;
  procedure Move; override;

  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;// reintroduce;// override;

  procedure CollideCheck(DestObj: TSpaceObject; Distance: Integer;
  var Accept: Boolean); override;

  procedure ObjectCollide(DestObj: TSpaceObject); override;

  procedure Render(Tag: TObject); override;
  procedure Explosion(); override;

 end;


//----------------------------------TBullet-----------------------------------------


 TBullet =  class(TSpaceObject)

 private
 protected
 public

     Pattern : integer;
     Angle: integer;


  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;

  procedure ObjectCollide(DestObj: TSpaceObject); override;
  procedure Render(Tag: TObject); override;
  procedure Explosion(); override;
  procedure Move; override;

 end;


//----------------------------------THammerBullet-----------------------------------------


 THammerBullet =  class(TSpaceObject)

 private
 protected
 public

     Angle : single;


  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;

  procedure ObjectCollide(DestObj: TSpaceObject); override;
  procedure Render(Tag: TObject); override;
  procedure Explosion(); override;
  procedure Move; override;

 end;


//----------------------------------TEnemyShip-----------------------------------------


 TEnemyShip =  class(TSpaceObject)

 private
 protected
 public

     PathType,PathAux1,PathAux2 : integer;
     PathAuxBool1,PathAuxBool2 : boolean;
     Fragments: integer;

     ShotsDone: integer;
     ShotsInRow: integer;
     LastRow:integer;
     LastShot: integer;
     ReloadTime: integer;
     RowReloadTime:integer;
     InRow: boolean;
     NextShot :integer;


     MaxAccel : TPoint2;//abs. values
     MaxSpeed : TPoint2;//abs. values

  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;
  procedure Explosion(); override;
  procedure Move; override;
  procedure Shoot; virtual; abstract;
  procedure CalculatePath;
 end;


//----------------------------------TEnemy1-----------------------------------------


 TEnemy1 =  class(TEnemyShip)

 private
 protected
 public

  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;

  procedure ObjectCollide(DestObj: TSpaceObject); override;
  procedure Shoot; override;

 end;



//----------------------------------TEnemy2-----------------------------------------


 TEnemy2 =  class(TEnemyShip)

 private
 protected
 public


  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;
  procedure ObjectCollide(DestObj: TSpaceObject); override;
  procedure Shoot; override;

 end;



//----------------------------------TEnemy3-----------------------------------------


 TEnemy3 =  class(TEnemyShip)

 private
 protected
 public


  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;
  procedure ObjectCollide(DestObj: TSpaceObject); override;
  procedure Shoot; override;

 end;



//----------------------------------TEnemy4-----------------------------------------


 TEnemy4 =  class(TEnemyShip)

 private
 protected
 public


  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;
  procedure ObjectCollide(DestObj: TSpaceObject); override;
  procedure Shoot; override;
  procedure Explosion(); override;
 end;

//----------------------------------TBoss-----------------------------------------


 TBoss=  class(TSpaceObject)

 private
 protected
 public

 ShotsDone: integer;
 ShotsInRow: integer;
 LastRow:integer;
 LastShot: integer;
 ReloadTime: integer;
 RowReloadTime:integer;
 InRow: boolean;

 Up:boolean;


  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;
  procedure ObjectCollide(DestObj: TSpaceObject); override;
  procedure Shoot; 
  procedure Explosion(); override;
  procedure Move; override;
  procedure Render(Tag: TObject); override;

 end;

//----------------------------------THammerHead-----------------------------------------


 THammerHead=  class(TSpaceObject)

 private
 protected
 public

  Cycles: integer;

  constructor Create(AOwner: TObjectManager; APosition: TPoint2); override;
  procedure ObjectCollide(DestObj: TSpaceObject); override;
  procedure Move; override;

 end;




//------------------------------------------------------------------------------






var PlayerShip: TPlayerShip;
    Boss : TBoss;
    ShowCollide: boolean;
    ShowFPS: boolean;

    ManagerBulletsFriendly,ManagerBulletsEnemy,ManagerEnemyShips: TObjectManager;
    FragmentManager: TFragmentManager;

    GCanvas : TAsphyreCanvas;
    GImages : TAsphyreImages;

    victory : boolean;
    victorytime: integer;
    defeat : boolean;
    defeattime: integer;

    bossready : boolean;
    passedtime: integer;
    introcompleted: boolean;

    paused: boolean;
    LostFocus: boolean;

    minimalized: boolean;
    pausedtime: integer;

    MakeCollisions: boolean;
    MakeMove: boolean;
    ShowPosition: boolean;
    MovedByX: integer;


    Score: integer;






//------------------------------------------------------------------------------



implementation




//------------------------GetRadialValues--------------------------------------

function GetRadialValues (radius: real):TPoint2;
var vektor:Tpoint2;
BEGIN

vektor.y:=(random(round((radius*1000*2))) / 1000.0)-radius;
vektor.x:=(sqrt(sqr(radius) - sqr(vektor.y)))*(1.0-((random(2)*2)));

GetRadialValues:=vektor;

END;



//---------------------------------------------------------------------------
//------------------------TFragment------------------------------------------
//---------------------------------------------------------------------------

procedure TFragment.Unlink();
begin
 // 1. unlink the object from its owner
 if (Assigned(Owner)) then Owner.UnlinkObj(Self);

 // 2. unlink previous node
 if (Prev <> nil) then Prev.Next := Next;
 if (Next <> nil) then Next.Prev := Prev;
end;


//---------------------------------------------------------------------------

procedure TFragment.Move();
begin
 Position.X:= Position.X + Velocity.X;
 Position.Y:= Position.Y + Velocity.Y;

 velocity.x := velocity.x/1.05;
 velocity.y := velocity.y/1.05;

 inc(duration);
 if duration > maxduration then dying := true;
end;

//---------------------------------------------------------------------------

procedure TFragment.Render(Tag: TObject);
var
 Alpha: Cardinal;
begin
Alpha:= 255 - ((Duration * 255) div (MaxDuration));
 GCanvas.PutPixel(Position, $FFFFFF or (Alpha shl 24), Effect);
end;

//---------------------------------------------------------------------------

constructor TFragment.Create(AOwner: TFragmentManager; APosition: TPoint2;AVelocity: TPoint2; AMaxDuration:integer);
begin
 inherited Create();

 Prev:= nil;
 Next:= nil;
 Owner:= AOwner;
 Position:= APosition;
 Velocity:= AVelocity;

 MaxDuration := AMaxDuration;

 Color := $FFFFFFFF;
 Effect := doxDraw;

 if (Assigned(Owner)) then
  begin
   Owner.Insert(Self);
  end;
end;

//---------------------------------------------------------------------------

destructor TFragment.Destroy();
begin
Unlink();
inherited;
end;

//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
//--------------------TSpaceObject-------------------------------------------------------
//---------------------------------------------------------------------------

constructor TSpaceObject.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
 inherited Create();

 Prev:= nil;
 Next:= nil;
 Owner:= AOwner;
 Position:= APosition;
 Velocity:= Point2(0, 0);
 Dying:= False;

 CollisionAreas := 0;


 Collided:= False;

 if (Assigned(Owner)) then
  begin
   Owner.Insert(Self);
  end;
end;

//---------------------------------------------------------------------------
destructor TSpaceObject.Destroy();
begin
 Unlink();
 inherited;
end;

//---------------------------------------------------------------------------
procedure TSpaceObject.GetDamage(damage:integer);
begin
if defeat=false then
     begin
          Life := Life - damage;
          if Life < 1 then
          begin
               dying := true;
               explosion;
          end;
     end;
end;

//---------------------------------------------------------------------------
procedure TSpaceObject.CollideCheck(DestObj: TSpaceObject;Distance: Integer; var Accept: Boolean);
begin
 // no code
 accept := true;
end;

//---------------------------------------------------------------------------
procedure TSpaceObject.ObjectCollide(DestObj: TSpaceObject);
begin
 // no code
end;

//---------------------------------------------------------------------------

procedure TSpaceObject.Unlink();
begin
 // 1. unlink the object from its owner
 if (Assigned(Owner)) then Owner.UnlinkObj(Self);

 // 2. unlink previous node
 if (Prev <> nil) then Prev.Next := Next;
 if (Next <> nil) then Next.Prev := Prev;
end;

//---------------------------------------------------------------------------
procedure TSpaceObject.Move();
begin
 Position.X:= Position.X + Velocity.X;
 Position.Y:= Position.Y + Velocity.Y;

 Collided:= False;
end;

//---------------------------------------------------------------------------

procedure TSpaceObject.RenderCollision();
var
  i:integer;
begin

     for i := 1 to CollisionAreas do
     GCanvas.FillQuad                   (pBounds4 (
                                                  TempCollisionArea[i].Left+round(position.X),
                                                  TempCollisionArea[i].Top+round(position.Y),
                                                  TempCollisionArea[i].Right-TempCollisionArea[i].Left,
                                                  TempCollisionArea[i].Bottom-TempCollisionArea[i].Top
                                                  ),
                                        cColor4   ($FFFF00FF,$FF0099FF,$FFFF00FF,$FFFF99FF),
                                        doxDraw);

end;

//---------------------------------------------------------------------------

procedure TSpaceObject.AddCollisionArea (plocha: TRect);
begin
CollisionAreas := CollisionAreas+1;
CollisionArea[CollisionAreas] := plocha;
end;

//---------------------------------------------------------------------------

procedure TSpaceObject.Render(Tag: TObject);
begin
 GCanvas.Draw(Image,position.x,position.y,0,doxDraw);
end;

//---------------------------------------------------------------------------

procedure TSpaceObject.Explosion();
begin
 //do nothing
end;


//---------------------------------------------------------------------------

procedure TSpaceObject.CopyCollisionAreas();
var i : integer;
begin
for i := 1 to CollisionAreas do TempCollisionArea[i] := CollisionArea[i];
end;




//---------------------------------------------------------------------------
//----------------------------TFragmentManager-------------------------------
//---------------------------------------------------------------------------

constructor TFragmentManager.Create();
begin
 inherited;
 ListTail := nil;
 ListHead := nil;
end;


//---------------------------------------------------------------------------

destructor TFragmentManager.Destroy();
begin
RemoveAll;
 inherited;
end;



//---------------------------------------------------------------------------


procedure TFragmentManager.UnlinkObj(Obj: TFragment);
begin
 if (ListTail = Obj) then ListTail:= ListTail.Prev;

 if (ListHead = Obj) then
  begin 
   ListHead:= nil;
   if (Obj.Next <> nil) then ListHead:= Obj.Next;
  end;
end;


//---------------------------------------------------------------------------

function TFragmentManager.GetCount(): Integer;
var
 Aux: TFragment;
begin
 Result:= 0;
 Aux:= ListHead;

 while (Aux <> nil) do
  begin
   Aux:= Aux.Next;
   Inc(Result);
  end;
end;


//---------------------------------------------------------------------------


procedure TFragmentManager.Render(Tag: TObject);
var
 Aux: TFragment;
begin
 Aux:= ListHead;
 while (Aux <> nil) do
  begin
   if (not Aux.Dying) then
     begin
     Aux.Render(Tag);
     end;
   Aux:= Aux.Next;
  end;
end;

//---------------------------------------------------------------------------
procedure TFragmentManager.RemoveAll();
var
 Aux, Prev: TFragment;
begin
 Aux:= ListTail;
 while (Aux <> nil) do
  begin
   Prev:= Aux.Prev;
   Aux.Free();
   Aux:= Prev;
  end;
end;

//---------------------------------------------------------------------------


procedure TFragmentManager.Update();
var
 Aux, Temp: TFragment;
 Died: Boolean;
begin

 Aux:= ListHead;
 while (Aux <> nil) do
  begin
   Died:= False;


   if (Aux.Dying) then
    begin
     Temp:= Aux;
     Aux:= Aux.Next;

     Temp.Free();
     Died:= True;
    end;

   // 3 (b). move the object
   if (not Died) then Aux:= Aux.Next;
  end;

  // MOVE all fragments
 Aux:= ListHead;
 while (Aux <> nil) do
  begin
   Aux.Move();
   Aux:= Aux.Next;
  end;


end;




//---------------------------------------------------------------------------
procedure TFragmentManager.Insert(Obj: TFragment);
begin
 //if (Obj = nil) then Exit;

 // if no items available - create a first element
 if (ListHead = nil) then
  begin
   Obj.Prev:= nil;
   Obj.Next:= nil;
   ListHead:= Obj;
   ListTail:= ListHead;
   //Exit;
  end
  else
 //  insert AFTER last element
  begin
   Obj.Next:= nil;
   Obj.Prev := ListTail;
   ListTail.Next:= Obj;
   ListTail:= Obj;
  // Exit;
  end;
end;


//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
//----------------------------TObjectManager-------------------------------
//---------------------------------------------------------------------------


constructor TObjectManager.Create();
begin
 inherited;
 FCollideFreq:= 2;
 FCollideLast := 1;
 ListTail := nil;
 ListHead := nil;
end;

//---------------------------------------------------------------------------

destructor TObjectManager.Destroy();
begin
 RemoveAll();
 inherited;
end;

//---------------------------------------------------------------------------
procedure TObjectManager.UnlinkObj(Obj: TSpaceObject);
begin
 if (ListTail = Obj) then ListTail:= ListTail.Prev;

 if (ListHead = Obj) then
  begin 
   ListHead:= nil;
   if (Obj.Next <> nil) then ListHead:= Obj.Next;
  end;
end;

//---------------------------------------------------------------------------

function TObjectManager.GetCount(): Integer;
var
 Aux: TSpaceObject;
begin
 Result:= 0;
 Aux:= ListHead;

 while (Aux <> nil) do
  begin
   Aux:= Aux.Next;
   Inc(Result);
  end;
end;


//---------------------------------------------------------------------------



procedure TObjectManager.DoCollide(Obj: TSpaceObject);
var
 Aux: TSpaceObject;
 Delta: Real;
 TooClose: Boolean;
 Accept1, Accept2: Boolean;   i,ii: integer;    temprect: Trect;
begin
FCollideLast := FCollideLast+1;
if FCollideLast>FCollideFreq then
BEGIN
 Aux:= ListHead;
 while (Aux <> nil) do
  begin
   if (not Aux.Dying)and(not Aux.Collided) then
    begin
     Delta:= Sqrt(Sqr(Obj.Position.X - Aux.Position.X) + Sqr(Obj.Position.Y - Aux.Position.Y));

     obj.CopyCollisionAreas;
     aux.CopyCollisionAreas;
       TooClose := false;
       for i := 1 to Obj.CollisionAreas do
          for ii := 1 to Aux.CollisionAreas do
               if TooClose=false
               then
                    begin
                    TooClose:= OverlapRect(
                                             rect(
                                                  Obj.TempCollisionArea[i].Left+round(Obj.Position.x),
                                                  Obj.TempCollisionArea[i].Top+round(Obj.Position.y),
                                                  Obj.TempCollisionArea[i].Right+round(Obj.Position.x),
                                                  Obj.TempCollisionArea[i].Bottom+round(Obj.Position.y)
                                                  )
                                             ,

                                              rect(
                                                  Aux.TempCollisionArea[ii].Left+round(Aux.Position.x),
                                                  Aux.TempCollisionArea[ii].Top+round(Aux.Position.y),
                                                  Aux.TempCollisionArea[ii].Right+round(Aux.Position.x),
                                                  Aux.TempCollisionArea[ii].Bottom+round(Aux.Position.y)
                                                  )
                                             );
                    if tooclose then
                         begin

                              temprect := rect (
                                                  max (Obj.TempCollisionArea[i].Left+round(Obj.Position.x),Aux.TempCollisionArea[ii].Left+round(Aux.Position.x)),
                                                  max (Obj.TempCollisionArea[i].Top+round(Obj.Position.y),Aux.TempCollisionArea[ii].Top+round(Aux.Position.y)),
                                                  min (Obj.TempCollisionArea[i].Right+round(Obj.Position.x),Aux.TempCollisionArea[ii].Right+round(Aux.Position.x)),
                                                  min (Obj.TempCollisionArea[i].Bottom+round(Obj.Position.y),Aux.TempCollisionArea[ii].Bottom+round(Aux.Position.y))
                                                  );
                             Obj.LastCollisionCenter := point2((temprect.Left+temprect.Right)/2,(temprect.Top+temprect.Bottom)/2);
                             aux.LastCollisionCenter := obj.LastCollisionCenter;
                         end;
                    end;


     if (TooClose) then
      begin
       Accept1:= True;
       Accept2:= True;
       Obj.CollideCheck(Aux, Trunc(Delta), Accept1);
       Aux.CollideCheck(Obj, Trunc(Delta), Accept2);



       if (Accept1)and(Accept2) then
        begin
         Obj.Collided:= True;
         Aux.Collided:= True;

         Obj.ObjectCollide(Aux);
         Aux.ObjectCollide(Obj);

         if (Obj.Collided) then Break;
        end;
      end;
    end;

   Aux:= Aux.Next;
  end;
 END;
end;


//---------------------------------------------------------------------------
procedure TObjectManager.CollideWithManager(Cil: TObjectManager);
 var Aux: TSpaceObject;
begin
     if Cil = nil then Exit;

     Aux := ListHead;
     while Aux <> nil do
          begin
          Cil.DoCollide(Aux);
          Aux := aux.next;
          end;
end;

//---------------------------------------------------------------------------

procedure TObjectManager.Render(Tag: TObject);
var
 Aux: TSpaceObject;
begin
 Aux:= ListHead;
 while (Aux <> nil) do
  begin
   if (not Aux.Dying) then
     begin
     if (Aux.Position.x>-64) and (Aux.Position.x<364) and (Aux.Position.y>-64) and (Aux.Position.y<264) then Aux.Render(Tag);
     if showcollide then Aux.RenderCollision;
     end;
   Aux:= Aux.Next;
  end;
end;



//---------------------------------------------------------------------------

procedure TObjectManager.RemoveAll();
var
 Aux, Prev: TSpaceObject;
begin
 Aux:= ListTail;
 while (Aux <> nil) do
  begin
   Prev:= Aux.Prev;
   Aux.Free();
   Aux:= Prev;
  end;
end;

//---------------------------------------------------------------------------

procedure TObjectManager.Move();
var
 Aux: TSpaceObject;
begin
 Aux:= ListHead;
 while (Aux <> nil) do
  begin

   if aux.Position.x>(xsize+10) then Aux.Position.x := Aux.Position.x-1
   else Aux.Move();

   Aux:= Aux.Next;
  end;
end;


//---------------------------------------------------------------------------
procedure TObjectManager.MoveALLbyX(x:integer);
var
 Aux: TSpaceObject;
begin
 Aux:= ListHead;
 while (Aux <> nil) do
  begin
        Aux.Position.x := (aux.Position.x)+(x);
   Aux:= Aux.Next;
  end;

  MovedByX := MovedByX+x;
end;

//---------------------------------------------------------------------------



procedure TObjectManager.Update();
var
 Aux, Temp: TSpaceObject;
 Died: Boolean;
begin

 Aux:= ListHead;
 while (Aux <> nil) do
  begin
   Died:= False;

   if (Aux.Dying) then
    begin
    Score:= Score+aux.ScoreValue;
     Temp:= Aux;
     Aux:= Aux.Next;

     Temp.Free();
     Died:= True;

    end;

   if (not Died) then Aux:= Aux.Next;
  end;
end;

//---------------------------------------------------------------------------







//---------------------------------------------------------------------------
procedure TObjectManager.Insert(Obj: TSpaceObject);
begin

 if (ListHead = nil) then
  begin
   Obj.Prev:= nil;
   Obj.Next:= nil;
   ListHead:= Obj;
   ListTail:= ListHead;
  end
  else

  begin
   Obj.Next:= nil;
   Obj.Prev := ListTail;
   ListTail.Next:= Obj;
   ListTail:= Obj;
  end;
end;











//---------------------------------------------------------------------------
//----------------------------TPlayerShip------------------------------------
//---------------------------------------------------------------------------


procedure TPlayerShip.GetDamage(damage:integer);
begin
if victory=false then
     begin
       inherited;
       if dying then defeat := true;
     end;
end;

//---------------------------------------------------------------------------

procedure TPlayerShip.Shoot1;
var bullet: TBullet;
begin
  if LastShot>PlayerShootFreqMin then
     begin
  bullet := TBullet.Create(ManagerBulletsFriendly,point2(position.x+9,position.y+7));
  bullet.Velocity := point2(3,0);
  LastShot := 0;
     end;
end;



//---------------------------------------------------------------------------

procedure TPlayerShip.Shoot2;
var bullet: TBullet;
begin
  if LastShot>PlayerShootFreq then
     begin
          bullet := TBullet.Create(ManagerBulletsFriendly,point2(position.x+9,position.y+7));
          bullet.Velocity := point2(3,0);
          LastShot := 0;
     end;
end;


//---------------------------------------------------------------------------

procedure TPlayerShip.Move;
begin
  inherited;

  inc(LastShot);

IF introcompleted=true then
begin
  if position.X > maxxposition then
     begin
          position := Point2(maxxposition,position.y);
          velocity := Point2(0,velocity.y);
     end;
if position.X < minxposition then
     begin
          position := Point2(minxposition,position.y);
          velocity := Point2(0,velocity.y);
     end;
if position.Y > maxyposition then
     begin
          position := Point2(position.x,maxyposition);
          velocity := Point2(velocity.x,0);
     end;
if position.Y < minyposition then
     begin
          position := Point2(position.x,minyposition);
          velocity := Point2(velocity.x,0);
     end;
end;


   if abs(velocity.X) < 0.05 then velocity := Point2 (0,velocity.Y);
   if abs(velocity.Y) < 0.05 then velocity := Point2 (velocity.X,0);

  velocity := Point2 (velocity.X/1.1,velocity.Y/1.1);

  end;


//---------------------------------------------------------------------------

constructor TPlayerShip.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
      inherited;
      Image :=GIMages.Image['playership'];
      Accel := 0.2;
      Speed := 2;
      AddCollisionArea(bounds(2,2,10,10));
      Life := 10;
end;

//---------------------------------------------------------------------------

procedure TPlayerShip.CollideCheck(DestObj: TSpaceObject; Distance: Integer;
var Accept: Boolean);
begin

end;

//---------------------------------------------------------------------------

procedure TPlayerShip.ObjectCollide(DestObj: TSpaceObject);
begin
    DestObj.GetDamage(1);
end;

//---------------------------------------------------------------------------

procedure TPlayerShip.Render(Tag: TObject);
begin
       inherited;
end;

//---------------------------------------------------------------------------

procedure TPlayerShip.Explosion();
var i : integer;
begin
    for i := 1 to 100 do TFragment.Create(FragmentManager,Point2(position.x+20,position.y+20),point2((random(41)-20)/3,(random(41)-20)/3),20);
end;

//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
//----------------------------TBullet------------------------------------
//---------------------------------------------------------------------------

constructor TBullet.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
      inherited;
      Image :=GIMages.Image['bullet'];
      Pattern := random(2);
      AddCollisionArea(bounds(1,0,3,2));
end;

//---------------------------------------------------------------------------

procedure TBullet.ObjectCollide(DestObj: TSpaceObject);
begin
dying := true;
DestObj.GetDamage(1);
dying := true;
end;

//---------------------------------------------------------------------------

procedure TBullet.Render(Tag: TObject);
begin
      if angle = 0 then GCanvas.Draw(Image,position.x,position.y,Pattern,doxDraw)
      else GCanvas.Rotate(Image,position.x,position.y,Angle /(2*pi),1,Pattern,doxDraw);
end;

//---------------------------------------------------------------------------

procedure TBullet.Explosion();
begin
TFragment.Create(FragmentManager,Point2(position.x+5,position.y+5),point2((random(21)-10)/6,(random(21)-10)/6),20);
TFragment.Create(FragmentManager,Point2(position.x+5,position.y+5),point2((random(21)-10)/6,(random(21)-10)/6),20);
end;

//---------------------------------------------------------------------------

procedure TBullet.Move();
begin
inherited;
if position.x> (maxxposition+14) then dying := true;
end;

//---------------------------------------------------------------------------








//---------------------------------------------------------------------------
//----------------------------THammerBullet------------------------------------
//---------------------------------------------------------------------------

constructor THammerBullet.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
      inherited;
      Image := GIMages.Image['hammerbullet'];
      Angle := 0;
      AddCollisionArea(bounds(-2,-2,5,5));

end;


//---------------------------------------------------------------------------

procedure THammerBullet.ObjectCollide(DestObj: TSpaceObject);
begin
DestObj.GetDamage(2);
dying := true;
end;


//---------------------------------------------------------------------------

procedure THammerBullet.Render(Tag: TObject);
begin
      GCanvas.Rotate(Image,position.x,position.y,Angle,1,0,doxDraw);
end;


//---------------------------------------------------------------------------

procedure THammerBullet.Explosion();
begin
TFragment.Create(FragmentManager,Point2(position.x+5,position.y+5),point2((random(21)-10)/6,(random(21)-10)/6),20);
TFragment.Create(FragmentManager,Point2(position.x+5,position.y+5),point2((random(21)-10)/6,(random(21)-10)/6),20);
TFragment.Create(FragmentManager,Point2(position.x+5,position.y+5),point2((random(21)-10)/6,(random(21)-10)/6),20);
TFragment.Create(FragmentManager,Point2(position.x+5,position.y+5),point2((random(21)-10)/6,(random(21)-10)/6),20);
TFragment.Create(FragmentManager,Point2(position.x+5,position.y+5),point2((random(21)-10)/6,(random(21)-10)/6),20);
end;

//---------------------------------------------------------------------------

procedure THammerBullet.Move();
begin
inherited;
if position.x> (maxxposition+14) then dying := true;
end;

//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
//----------------------------TEnemyShip------------------------------------
//---------------------------------------------------------------------------

procedure TEnemyShip.CalculatePath;
var ax,ay,faktor,wx,wy: real;
begin
   case PathType of
     pathStraight :
               begin
                    if not(abs(Velocity.X)>MaxSpeed.x) then
                         begin
                         Velocity := Point2(Velocity.X-MaxAccel.x,Velocity.Y);
                         if (abs(Velocity.X)>MaxSpeed.x) then Velocity  := Point2(-MaxSpeed.x,Velocity.y);
                         end;
               end;


     pathToXYThenContinue ,pathToXYThenStraight:
               begin  //aux1=X;aux2=Y;
                         if position.x<PathAux1 then
                              begin
                                   Velocity := Point2(Velocity.X-MaxAccel.x,Velocity.Y);
                                   if (abs(Velocity.X)>MaxSpeed.x) then Velocity  := Point2(-MaxSpeed.x,Velocity.y);
                              end
                         else
                              begin

                                   ax :=abs(PathAux1-position.X);
                                   ay :=abs(PathAux2-position.Y);

                                   if maxspeed.x=0 then maxspeed := Point2(0.1,maxspeed.Y);
                                   if maxspeed.y=0 then maxspeed := Point2(maxspeed.X,0.1);

                                   faktor := max(ax/maxspeed.X,ay/maxspeed.Y);
                                   wx := abs(ax/faktor);
                                   wy := abs(ay/faktor);



                                   Velocity := Point2(Velocity.X-MaxAccel.x,Velocity.Y);
                                   if (abs(Velocity.X)>wx) then Velocity  := Point2(-wx,Velocity.y);

                                   if (position.y>PathAux2) then
                                        begin
                                             Velocity := Point2(Velocity.X,Velocity.Y-MaxAccel.y);
                                             if (abs(Velocity.Y)>wY) then Velocity  := Point2(Velocity.x,-wy);
                                        end
                                   else
                                        begin
                                             Velocity := Point2(Velocity.X,Velocity.Y+MaxAccel.y);
                                             if (abs(Velocity.Y)>wY) then Velocity  := Point2(Velocity.x,wy);
                                        end;

                                   if PathType<>pathToXYThenContinue then
                                   BEGIN
                                        if ((position.Y+1)>PathAux2) and ((position.Y-1)<PathAux2) then
                                        begin
                                        position.Y := PathAux2;
                                        Velocity := Point2 (velocity.X,0);
                                        end;
                                   END;

                              end;

               end;

     pathSinusoid :
               begin
                    if not(abs(Velocity.X)>MaxSpeed.x) then
                         begin
                         Velocity := Point2(Velocity.X-MaxAccel.x,Velocity.Y);
                         if (abs(Velocity.X)>MaxSpeed.x) then Velocity  := Point2(-MaxSpeed.x,Velocity.y);
                         end;

                    //aux1,2=borders;

                      if (position.y>(PathAux2+PathAux1)) then PathAuxBool1 := false;
                      if (position.y<(PathAux2-PathAux1)) then PathAuxBool1 := true;

                      if (PathAuxBool1=false) then  //false -> FLY UP
                         begin
                              Velocity := Point2(Velocity.X,Velocity.Y-MaxAccel.Y);
                              if (Velocity.Y<-MaxSpeed.Y) then Velocity  := Point2(Velocity.X,-MaxSpeed.Y);
                         end
                              else      //true -> FLY DOWN
                         begin
                              Velocity := Point2(Velocity.X,Velocity.Y+MaxAccel.Y);
                              if (Velocity.Y>MaxSpeed.Y) then Velocity  := Point2(Velocity.X,MaxSpeed.Y);
                         end;

               end;


     pathCopy :
               begin
                    if not(abs(Velocity.X)>MaxSpeed.x) then
                         begin
                         Velocity := Point2(Velocity.X-MaxAccel.x,Velocity.Y);
                         if (abs(Velocity.X)>MaxSpeed.x) then Velocity  := Point2(-MaxSpeed.x,Velocity.y);
                         end;

                      if (position.y>PlayerShip.Position.y) then
                         begin
                              Velocity := Point2(Velocity.X,Velocity.Y-MaxAccel.Y);
                              if (Velocity.Y<-MaxSpeed.Y) then Velocity  := Point2(Velocity.X,-MaxSpeed.Y);
                         end
                              else
                         begin
                              Velocity := Point2(Velocity.X,Velocity.Y+MaxAccel.Y);
                              if (Velocity.Y>MaxSpeed.Y) then Velocity  := Point2(Velocity.X,MaxSpeed.Y);
                         end;
               end;



     end;//case
end;


//---------------------------------------------------------------------------

constructor TEnemyShip.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
inherited;
ScoreValue := 0;
end;

//---------------------------------------------------------------------------

procedure TEnemyShip.Explosion();
var i : integer;
begin
for i := 1 to fragments do TFragment.Create(FragmentManager,Point2(position.x+5,position.y+5),point2((random(21)-10)/6,(random(21)-10)/6),20);
end;


//---------------------------------------------------------------------------

procedure TEnemyShip.Move;
begin
CalculatePath;
inherited;


if position.x>0 then
if InRow then
     begin
          LastShot := LastShot+1;
          if LastShot > ReloadTime then
               begin
               LastShot := 0;
               Shoot;

               ShotsDone := ShotsDone+1;
               if ShotsDone=ShotsInRow then
                    begin
                    ShotsDone := 0;
                    LastRow:=0;
                    InRow := false;
                    end;
               end;
     end
     else
     begin
       LastRow := LastRow+1;
          if LastRow > RowReloadTime then
               begin
               LastRow := 0;
               inrow := true;


               end;
     end;
end;





//---------------------------------------------------------------------------
//----------------------------TEnemy1------------------------------------
//---------------------------------------------------------------------------

constructor TEnemy1.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
inherited;

      Image :=GIMages.Image['enemy1'];
      AddCollisionArea(bounds(2,2,10,11));

      ShotsInRow := 1;
      ReloadTime := 0;
      RowReloadTime := random(50)+130;

      Life := 1;
      Fragments := 8;
      ScoreValue := 1;
end;

//---------------------------------------------------------------------------

procedure TEnemy1.ObjectCollide(DestObj: TSpaceObject);
begin
dying := true;
DestObj.GetDamage(2);

end;


//---------------------------------------------------------------------------

procedure TEnemy1.Shoot;
var bullet: TBullet;
begin
     bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x+9,position.y+7));
     bullet.Velocity := point2(-3,0);
end;

//---------------------------------------------------------------------------









//---------------------------------------------------------------------------
//----------------------------TEnemy2------------------------------------
//---------------------------------------------------------------------------



constructor TEnemy2.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
inherited;

      Image :=GIMages.Image['enemy2'];
      AddCollisionArea(bounds(2,2,13,12));

      MaxSpeed := point2 (0.8,0.4);
      MaxAccel := point2 (0.05,0.03);

      ShotsInRow := 2;
      ReloadTime := 15;
      RowReloadTime := 170;

      Life := 3;
      Fragments := 24;
      ScoreValue := 3;
end;

//---------------------------------------------------------------------------

procedure TEnemy2.ObjectCollide(DestObj: TSpaceObject);
begin
DestObj.GetDamage(2);

end;

//---------------------------------------------------------------------------

procedure TEnemy2.Shoot;
var bullet: TBullet;
begin
  bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x,position.y+1));
  bullet.Velocity := point2(-3,0);

  bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x,position.y+11));
  bullet.Velocity := point2(-3,0);
end;

//---------------------------------------------------------------------------







//---------------------------------------------------------------------------
//----------------------------TEnemy3------------------------------------
//---------------------------------------------------------------------------



constructor TEnemy3.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
inherited;

      Image :=GIMages.Image['enemy3'];
      AddCollisionArea(bounds(2,2,10,13));

      maxspeed := point2 (0.8,0.4);
      maxaccel := point2 (0.05,0.03);

      ShotsInRow := 1;
      ReloadTime := 0;
      RowReloadTime := 120;

      Life := 2;
      Fragments := 18;
      ScoreValue := 2;
end;

//---------------------------------------------------------------------------

procedure TEnemy3.ObjectCollide(DestObj: TSpaceObject);
begin                                                        
DestObj.GetDamage(2);

end;

//---------------------------------------------------------------------------

procedure TEnemy3.Shoot;
  var bullet: TBullet;
  begin
  bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x-1,position.y+2));
  bullet.Velocity := point2(-2.8,-0.3);

  bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x-1,position.y+9));
  bullet.Velocity := point2(-2.8,0.3);
  end;

//---------------------------------------------------------------------------








//---------------------------------------------------------------------------
//----------------------------TEnemy4------------------------------------
//---------------------------------------------------------------------------



constructor TEnemy4.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
inherited;

      Image :=GIMages.Image['enemy4'];
      AddCollisionArea(bounds(6,6,19,20));

      maxspeed := point2 (0.8,0.4);
      maxaccel := point2 (0.05,0.03);

      ShotsInRow := 1;
      ReloadTime := 10;
      RowReloadTime := 120;

      Life := 5;
      Fragments := 30;
      ScoreValue := 8;
end;


//---------------------------------------------------------------------------

procedure TEnemy4.ObjectCollide(DestObj: TSpaceObject);
begin                                                        
DestObj.GetDamage(2);
end;

//---------------------------------------------------------------------------

procedure TEnemy4.Explosion();
var i : integer;
begin
for i := 1 to fragments do TFragment.Create(FragmentManager,Point2(position.x+12,position.y+12),point2((random(21)-10)/6,(random(21)-10)/6),20);
end;

//---------------------------------------------------------------------------

procedure TEnemy4.Shoot;
  var bullet: TBullet;
  begin




     begin
          bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x+3,position.y+12));
          bullet.Velocity := point2(-1.7+velocity.x,-0.7);
          bullet.Angle := 180;
     end;

     begin
          bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x+15,position.y+1));
          bullet.Velocity := point2(-0.1+velocity.x,-2);
          bullet.Angle := 90;
     end;

     begin
          bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x+31,position.y+10));
          bullet.Velocity := point2(1.8+velocity.x,-1);
          bullet.Angle := 20;
     end;


     begin
          bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x+24,position.y+24));
          bullet.Velocity := point2(1.1+velocity.x,1.5);
          bullet.Angle := 320;
     end;

     begin
          bullet := TBullet.Create(ManagerBulletsEnemy,point2(position.x+9,position.y+26));
          bullet.Velocity := point2(-1+velocity.x,1.5);
          bullet.Angle := 250;
     end;

  end;

//---------------------------------------------------------------------------









//---------------------------------------------------------------------------
//----------------------------TBoss------------------------------------
//---------------------------------------------------------------------------


constructor TBoss.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
inherited;

      Image :=GIMages.Image['boss'];
      AddCollisionArea(bounds(13,10,22,4));
      AddCollisionArea(bounds(16,22,38,5));
      AddCollisionArea(bounds(20,35,5,21));
      AddCollisionArea(bounds(34,10,6,30));

      ShotsInRow := 1;
      ReloadTime := 40;
      RowReloadTime := 240;

      Velocity.x := -0.5;

     THammerHead.Create(ManagerEnemyShips,point2(position.x+HammerHeadXDifference,position.y+HammerHeadYDifference));


      Life := BossMaxLife;
      ScoreValue := 100;
end;


//---------------------------------------------------------------------------

procedure TBoss.ObjectCollide(DestObj: TSpaceObject);
begin
destobj.GetDamage(10);
end;


//---------------------------------------------------------------------------

procedure TBoss.Shoot;
var HammerHead: THammerHead;
begin
HammerHead := THammerHead.Create(ManagerEnemyShips,point2(position.x+HammerHeadXDifference,position.y+HammerHeadYDifference));

if (ShotsDone+1)=ShotsInRow then HammerHead.Cycles := -RowReloadTime;
end;


//---------------------------------------------------------------------------



procedure TBoss.Explosion();
var i : integer;
begin
if defeat= false then victory := true;
for i := 1 to 100 do TFragment.Create(FragmentManager,Point2(position.x+20,position.y+20),point2((random(41)-20)/3,(random(41)-20)/3),random(20)+40);
for i := 1 to 50 do TFragment.Create(FragmentManager,Point2(position.x+20,position.y+20),GetRadialValues(3.0),random(20)+30);
for i := 1 to 50 do TFragment.Create(FragmentManager,Point2(position.x+20,position.y+20),GetRadialValues(1.5),random(20)+30);


end;


//---------------------------------------------------------------------------

procedure TBoss.Render(Tag: TObject);
begin
 inherited;
 if bossready then
     begin
                 GCanvas.Diffuse(GImages.Image['bosslife'],268,187,$FF707070,0,doxDiffuse);
                 GCanvas.Draw(GImages.Image['bosslife'],268,187,9-Life div 10,doxDraw);
     end;

end;





//---------------------------------------------------------------------------


procedure TBoss.Move;
begin
inherited;

if position.y>125 then up := true;
if position.y<35 then up := false;

if (position.x<255) and (Velocity.x<0) then
     begin
     Velocity.x := velocity.x+0.005;
     end;

if (Velocity.x<0.1) and (Velocity.x>-0.1) then
     begin
     velocity.x := 0;
     bossready := true;
     end;



if (up = true) and (velocity.y>-0.6) then
     begin
     Velocity.y := velocity.y-0.01;

     end;

if (up = false) and (velocity.y<0.6) then
     begin
     Velocity.y := velocity.y+0.01;
     end;



if bossready and InRow then
     begin
          LastShot := LastShot+1;
          if LastShot > ReloadTime then
               begin
               LastShot := 0;
               Shoot;

               ShotsDone := ShotsDone+1;
               if ShotsDone=ShotsInRow then
                    begin
                    ShotsDone := 0;
                    LastRow:=0;
                    InRow := false;
                    ShotsInRow := ShotsInRow+1;
                    end;
               end;
     end
     else
     begin
       LastRow := LastRow+1;
          if LastRow > RowReloadTime then
               begin
               LastRow := 0;
               inrow := true;


               end;
     end;
end;







//---------------------------------------------------------------------------
//----------------------------THammerHead------------------------------------
//---------------------------------------------------------------------------



constructor THammerHead.Create(AOwner: TObjectManager; APosition: TPoint2);
begin
inherited;

      Image :=GIMages.Image['hammerhead'];
      AddCollisionArea(bounds(4,2,8,13));

      velocity := point2(0,0);

      Life := 1000;  // well, actually this means it is immortal (no chance to get hit for 1000 life)
end;


//---------------------------------------------------------------------------

procedure THammerHead.ObjectCollide(DestObj: TSpaceObject);
begin
DestObj.GetDamage(10);
end;


//---------------------------------------------------------------------------

procedure THammerHead.Move;
var HammerBullet: THammerBullet;
begin
inherited;

if bossready then inc(cycles);

if victory=true then dying := true
                else
     begin


     If Cycles<=HammerHeadDispatch then
          begin
               position := point2(boss.Position.x+HammerHeadXDifference,boss.Position.y+HammerHeadYDifference);
          end;

     if bossready then
     begin
     If Cycles>HammerHeadDispatch then
          begin
               velocity := point2(velocity.x-0.02,boss.velocity.y);
          end;

     If Cycles>(HammerHeadDispatch+HammerHeadExplode) then
          begin
          dying := true;
          HammerBullet :=THammerBullet.Create(ManagerBulletsEnemy,point2(position.x+2,position.y+6));
          HammerBullet.Velocity := point2(-2*hammerspeedcoef,0);
          HammerBullet.Angle := 0;

          HammerBullet :=THammerBullet.Create(ManagerBulletsEnemy,point2(position.x+2,position.y+6));
          HammerBullet.Velocity := point2(-1.6*hammerspeedcoef,-1*hammerspeedcoef);
          HammerBullet.Angle := Pi/4;

          HammerBullet :=THammerBullet.Create(ManagerBulletsEnemy,point2(position.x+2,position.y+6));
          HammerBullet.Velocity := point2(-1.6*hammerspeedcoef,1*hammerspeedcoef);
          HammerBullet.Angle := -Pi/4;

          HammerBullet :=THammerBullet.Create(ManagerBulletsEnemy,point2(position.x+2,position.y+6));
          HammerBullet.Velocity := point2(0,-2*hammerspeedcoef);
          HammerBullet.Angle := Pi/2;

          HammerBullet :=THammerBullet.Create(ManagerBulletsEnemy,point2(position.x+2,position.y+6));
          HammerBullet.Velocity := point2(0,2*hammerspeedcoef);
          HammerBullet.Angle := -Pi/2;


          HammerBullet :=THammerBullet.Create(ManagerBulletsEnemy,point2(position.x+2,position.y+6));
          HammerBullet.Velocity := point2(1.6*hammerspeedcoef,-1*hammerspeedcoef);
          HammerBullet.Angle := 3*Pi/4;

          HammerBullet :=THammerBullet.Create(ManagerBulletsEnemy,point2(position.x+2,position.y+6));
          HammerBullet.Velocity := point2(1.6*hammerspeedcoef,1*hammerspeedcoef);
          HammerBullet.Angle := -3*Pi/4;
          end;
     end;
     end;
end;

//---------------------------------------------------------------------------



//end of gameobjects.pas
end.

